def bisection(f, a, b, tol=1e-10):
    """
Sucht eine Nullstelle der Funktion f(.) im Bereich (a,b). Die
Toleranz tol gibt dabei den oberen Fehler in der gefundenen
Nullstelle an. Die Funktion muss im Bereich (a,b) monoton sein!
    """  
    fa = f(a)
    fb = f(b)
    # Funktion immer steigend machen, evtl. Intervall umdrehen
    if fa > fb:
        # Austauschen der Grenzen und Werte
        a, b = b, a
        fa, fb = fb, fa
    if 0 < fa:
        raise "Keine Nullstelle im Intervall"

    while abs(a - b) > tol:
        # geometrisches Mittel der beiden Grenzen
        m = 0.5*(a + b)
        fmitte = f(m)
        if fmitte < 0:
            a = m
            fa = f(m)
        else:
            b = m
            fb = f(m)

    return 0.5*(a + b)

help(bisection)

def test(x): return x*x - 1

print bisection(test, 0.5, 1.5)
