#
# Demonstriert die Benutzung von optparse
#
#########################################

from optparse import OptionParser

parser = OptionParser()

# eine Option mit Parameter, der "filename" heisst.
# metavar bezeichnet in der Hilfe den Parameter, d.h. in der Hilfe steht
# "-f FILE" bzw "--file FILE"
parser.add_option("-f", "--file", dest = "filename",
                  help = "Ausgabe in FILE", metavar = "FILE")

# und eine ohne Parameter, die weniger Ausgabe erzwingt.
# Der Ausgabelevel ist in "verbose" gespeichert und normalerweise
# True, wird durch die Schalter "-q" oder "--quiet" aber auf False gesetzt
parser.add_option("-q", "--quiet",
                  action = "store_false", dest = "verbose", default = True,
                  help = "So wenige wie moeglich Ausgaben")

# ausserdem wird automatisch der Schalter "-h" bzw. "--help" erzeugt, der eine
# Liste der moeglichen Schalter und unsere Hilfetexte ausgibt.

# hier passiert das Zerlegen der Eingabeparameter
(options, args) = parser.parse_args()

# und hier machen wir etwas damit...

# wir oeffnen die angegebene Datei
# wenn nichts angegeben wurde, ist der Wert None
if options.filename == None: raise Exception("kein Dateiname angegeben")
file = open(options.filename, "w")
# und wenn wir viel ausgeben sollen, dann schreiben wir eben etwas extra
if options.verbose: file.write("eine sinnlose zusaetzliche Ausgabe\n")

file.write(str(args))
