#
# Bubble-Sort, ein klassischer Sortieralgorithmus
#
# Sortiert eine Liste in aufsteigender Reihenfolge.
# Die Liste wird dabei veraendert!
#
#################################################

import sys
from optparse import OptionParser

def bubblesort(liste):
    "sortiert die Liste liste in aufsteigender Reihenfolge"
    for runde in range(len(liste)):
        for k in range(len(liste) - 1):
            # wenn falsch herum, dann austauschen
            if liste[k] > liste[k+1]:
                liste[k], liste[k + 1] = liste[k+1], liste[k]

def ganzezahlen(liste):
    "wandelt alle Elemente der Liste in ganze Zahlen um"
    for k in range(len(liste)):
        try:
            liste[k] = int(liste[k])
        except:
            sys.stderr.write("die Liste enthielt %s, was keine ganze Zahl ist" % liste[k])

def fliesskommazahlen(liste):
    "wandelt alle Elemente der Liste in Fliesskommazahlen um"
    for k in range(len(liste)):
        try:
            liste[k] = float(liste[k])
        except:
            sys.stderr.write("die Liste enthielt %s, was keine Fliesskommazahl ist" % liste[k])

# Kommandozeile auslesen
# wir sortieren einfach alles, was wir als Parameter bekommen
parser = OptionParser(usage = "%prog [options] element1 element2 element3 ...")
# aber wenn es Zahlen bzw. Fliesskommazahlen sein sollen, muessen wir das wissen
# Der Typ steht in options.typ und ist entweder string, int oder float
parser.add_option("-f", help = "als Fliesskommazahlen sortieren",
                  action = "store_const", dest = "typ", const = "float", default = "string")
parser.add_option("-i", help = "als Ganzzahlen sortieren",
                  action = "store_const", dest = "typ", const = "int")
(options, liste) = parser.parse_args()

# wenn die Eingabe Zahlen sind, umwandeln
if options.typ == 'float':
    fliesskommazahlen(liste)
elif options.typ == 'int':
    ganzezahlen(liste)

bubblesort(liste)
print liste
