#
# Explizite Loesung der Dgl f''(x) = -k*f(x)
#
# Loesung sollte von der Form f(x) = a*sin(k*(x + b)) sein
#
##########################################################

from optparse import OptionParser
import sys
import pylab

# Diskretisierungsschritt, Defaultwert
dx = 0.01
# Konstante, Defaultwert
k = 1

# Parameter einlesen
parser = OptionParser("%prog [options] f(0) f'(0)")
parser.add_option("-d", help = "Zeitschritt dx", dest="dx", metavar="dx", default=dx, type=float)
parser.add_option("-k", help = "Frequenz k", dest="k", metavar="k", default=k, type=float)
(options,args) = parser.parse_args()
if len(args) < 2:
    sys.exit("nicht genuegend Startwerte, brauch Funktionswert und Ableitung\n")

# dx und k aus den Optionen holen
dx = options.dx
k = options.k

# Startwerte an der Stelle x = 0
f0  = float(args[0])
df0 = float(args[1])

f  = f0
df = df0

# Ergebniskurve
x=[]
y=[]

# integration ab x=0
for i in range(1000):
    ddf = -k*f
    df += ddf*dx
    f += df*dx
    x.append(i*dx)
    y.append(f)

# und plotten
pylab.plot(x, y)
pylab.show()
