#
# 3D-Plotting-Beispiel
#
###################################
import numpy as np
import matplotlib
import matplotlib.pyplot as pyplot
import mpl_toolkits.mplot3d as p3d

# Graphikfenster mit 2 Subgraphen
#################################

bild = pyplot.figure()

# Spirale
z = np.arange(0, 10, 0.1)
x = np.cos(z)
y = np.sin(z)

spirale = bild.add_subplot(211, title="Spirale")
graph_spirale = p3d.Axes3D(bild, rect=spirale.get_position())
graph_spirale.plot(x, y, z)

# Oberflaeche

# Ein paar Wellen
kx = np.arange(0, 2*np.pi, 0.1)
ky = np.arange(0, 2*np.pi, 0.1)

# Gitter ueber kx und ky erzeugen
x = np.outer(kx, np.ones(len(ky)))
y = np.outer(np.ones(len(kx)), ky)
z = np.outer(np.cos(kx), np.sin(ky))

oberfl = bild.add_subplot(212, title="Oberflaeche")
graph_oberfl = p3d.Axes3D(bild, rect=oberfl.get_position())
graph_oberfl.contourf3D(x, y, z, 40)

pyplot.show()
