#
# Wie man mehrere Graphen in ein Bild bekommt
# 
# Demonstration der verschiedenen logarithmischen Skalen
#
###################################
import numpy as np
import matplotlib
import matplotlib.pyplot as pyplot

x = np.arange(0, 10, 0.1)

# Graphikfenster mit 4 Subgraphen
#################################
bild = pyplot.figure()

graph_normal = bild.add_subplot(221, title="normal")
graph_normal.plot(x, np.exp(x), x, x**2, x, np.log(x))
graph_normal.set_ylim(-20,20)

graph_logx = bild.add_subplot(222, title="x logarithmisch")
graph_logx.plot(x, np.exp(x), x, x**2)
graph_logx.plot(x, np.log(x), linewidth=3)
graph_logx.set_xscale("log")
graph_logx.set_ylim(-20,20)

graph_logy = bild.add_subplot(223, title="y logarithmisch")
graph_logy.plot(x, np.exp(x), linewidth=3)
graph_logy.plot(x, x**2, x, np.log(x))
graph_logy.set_yscale("log")

graph_log = bild.add_subplot(224, title="voll logarithmisch")
graph_log.plot(x, np.exp(x))
graph_log.plot(x, x**2, linewidth=3)
graph_log.plot(x, np.log(x))
graph_log.set_xscale("log")
graph_log.set_yscale("log")

pyplot.show()
